OdeToFood/Pages/R2/Delete.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.EntityFrameworkCore;
using OdeToFood.Core;
using OdeToFood.Data;

namespace OdeToFood.Pages.R2
{
    public class DeleteModel : PageModel
    {
        private readonly OdeToFood.Data.OdeToFoodDBContext _context;

        public DeleteModel(OdeToFood.Data.OdeToFoodDBContext context)
        {
            _context = context;
        }

        [BindProperty]
        public Restaurant Restaurant { get; set; }

        public async Task<IActionResult> OnGetAsync(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            Restaurant = await _context.Restaurant.FirstOrDefaultAsync(m => m.Id == id);

            if (Restaurant == null)
            {
                return NotFound();
            }
            return Page();
        }

        public async Task<IActionResult> OnPostAsync(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            Restaurant = await _context.Restaurant.FindAsync(id);

            if (Restaurant != null)
            {
                _context.Restaurant.Remove(Restaurant);
                await _context.SaveChangesAsync();
            }

            return RedirectToPage("./Index");
        }
    }
}

OdeToFood/Pages/R2/Details.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.EntityFrameworkCore;
using OdeToFood.Core;
using OdeToFood.Data;

namespace OdeToFood.Pages.R2
{
    public class DetailsModel : PageModel
    {
        private readonly OdeToFood.Data.OdeToFoodDBContext _context;

        public DetailsModel(OdeToFood.Data.OdeToFoodDBContext context)
        {
            _context = context;
        }

        public Restaurant Restaurant { get; set; }

        public async Task<IActionResult> OnGetAsync(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            Restaurant = await _context.Restaurant.FirstOrDefaultAsync(m => m.Id == id);

            if (Restaurant == null)
            {
                return NotFound();
            }
            return Page();
        }
    }
}

OdeToFood/Pages/R2/Edit.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using OdeToFood.Core;
using OdeToFood.Data;

namespace OdeToFood.Pages.R2
{
    public class EditModel : PageModel
    {
        private readonly OdeToFood.Data.OdeToFoodDBContext _context;

        public EditModel(OdeToFood.Data.OdeToFoodDBContext context)
        {
            _context = context;
        }

        [BindProperty]
        public Restaurant Restaurant { get; set; }

        public async Task<IActionResult> OnGetAsync(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            Restaurant = await _context.Restaurant.FirstOrDefaultAsync(m => m.Id == id);

            if (Restaurant == null)
            {
                return NotFound();
            }
            return Page();
        }

        // To protect from overposting attacks, please enable the specific properties you want to bind to, for
        // more details see https://aka.ms/RazorPagesCRUD.
        public async Task<IActionResult> OnPostAsync()
        {
            if (!ModelState.IsValid)
            {
                return Page();
            }

            _context.Attach(Restaurant).State = EntityState.Modified;

            try
            {
                await _context.SaveChangesAsync();
            }
            catch (DbUpdateConcurrencyException)
            {
                if (!RestaurantExists(Restaurant.Id))
                {
                    return NotFound();
                }
                else
                {
                    throw;
                }
            }

            return RedirectToPage("./Index");
        }

        private bool RestaurantExists(int id)
        {
            return _context.Restaurant.Any(e => e.Id == id);
        }
    }
}

OdeToFood/Pages/Restaurants/ClientRestaurants.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using OdeToFood.Data;

namespace OdeToFood.Pages.Restaurants
{
    public class ClientRestaurantsModel : PageModel
    {
        private readonly IRestaurantData restaurantData;

        public ClientRestaurantsModel(IRestaurantData restaurantData)
        {
            this.restaurantData = restaurantData;
        }
        public void OnGet()
        {

        }
    }
}

OdeToFood/Pages/Restaurants/Delete.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using OdeToFood.Core;
using OdeToFood.Data;

namespace OdeToFood.Pages.Restaurants
{
    public class DeleteModel : PageModel
    {
        private readonly IRestaurantData restaurantData;
        [BindProperty]
        public Restaurant Restaurant { get; set; }
        public DeleteModel(IRestaurantData restaurantData)
        {
            this.restaurantData = restaurantData;
        }
        public IActionResult OnGet(int id)
        {
            Restaurant = restaurantData.GetRestaurant(id);
            if (Restaurant == null)
            {
                return RedirectToPage("./NotFound");
            }
            return Page();
        }

        public IActionResult OnPost(int id)
        {
            //if (Restaurant.Id > 0)
            //{
            //    restaurantData.Delete(Restaurant.Id);
            //}

            //restaurantData.Commit();
            //TempData["Message"] = "Restaurant has been deleted!";
            //return RedirectToPage("./List");

            var restaurant = restaurantData.Delete(id);
            restaurantData.Commit();

            if(restaurant == null)
            {
                return RedirectToPage("./NotFound");
            }

            TempData["Message"] = $"{restaurant.Name} has been deleted!";
            return RedirectToPage("./List");
        }
    }
}

OdeToFood/Pages/Restaurants/Details.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using OdeToFood.Core;
using OdeToFood.Data;

namespace OdeToFood.Pages.Restaurants
{
    public class DetailsModel : PageModel
    {
        private readonly IRestaurantData restaurantData;

        public Restaurant Restaurant { get; set; }
        [TempData]
        public string Message { get; set; }
        public DetailsModel(IRestaurantData restaurantData)
        {
            this.restaurantData = restaurantData;
        }
        public IActionResult OnGet(int id)
        {
            Restaurant = restaurantData.GetRestaurant(id);
            if(Restaurant == null)
            {
                return RedirectToPage("./NotFound");
            }
            return Page();
        }
    }
}

OdeToFood/Pages/Restaurants/Edit.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.AspNetCore.Mvc.Rendering;
using OdeToFood.Core;
using OdeToFood.Data;

namespace OdeToFood.Pages.Restaurants
{
    public class EditModel : PageModel
    {
        private readonly IRestaurantData restaurantData;
        private readonly IHtmlHelper htmlHelper;

        [BindProperty]
        public Restaurant Restaurant { get; set; }
        public IEnumerable<SelectListItem> Cuisines { get; set; }

        public EditModel(IRestaurantData restaurantData, IHtmlHelper htmlHelper)
        {
            this.restaurantData = restaurantData;
            this.htmlHelper = htmlHelper;
        }
        public IActionResult OnGet(int? id)
        {
            Cuisines = htmlHelper.GetEnumSelectList<CuisineType>();
            if (id.HasValue)
            {
                Restaurant = restaurantData.GetRestaurant(id.Value);
            }
            else
            {
                Restaurant = new Restaurant();
            }
            
            if(Restaurant == null)
            {
                return RedirectToPage("./NotFound");
            }
            return Page();
        }
        public IActionResult OnPost()
        {
            
            if (!ModelState.IsValid)
            {
                Cuisines = htmlHelper.GetEnumSelectList<CuisineType>();
                return Page();
            }

            if(Restaurant.Id > 0)
            {
                restaurantData.Update(Restaurant);
                TempData["Message"] = "Restaurant has been updated!";
            }
            else
            {
                restaurantData.Add(Restaurant);
                TempData["Message"] = "Restaurant has been saved!";
            }
            
            restaurantData.Commit();           
            return RedirectToPage("./Details", new { id = Restaurant.Id });
        }
    }
}

OdeToFood/Pages/Restaurants/Index.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;

namespace OdeToFood.Pages.Restaurants
{
    public class IndexModel : PageModel
    {
        public void OnGet()
        {

        }
    }
}

OdeToFood/Pages/Restaurants/List.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.Logging;
using OdeToFood.Core;
using OdeToFood.Data;

namespace OdeToFood.Pages.Restaurants
{
    public class ListModel : PageModel
    {
        [TempData]
        public string Message { get; set; }
        [BindProperty(SupportsGet = true)]
        public string SearchKeyword { get; set; }
        public IEnumerable<Restaurant> Restaurants { get; set; }

        private readonly IConfiguration config;
        private readonly IRestaurantData restaurantData;
        private readonly ILogger<ListModel> logger;

        public ListModel(IConfiguration configuration, IRestaurantData restaurantData, ILogger<ListModel> logger)
        {
            this.config = configuration;
            this.restaurantData = restaurantData;
            this.logger = logger;
        }
        public void OnGet()
        {
            logger.LogError("Executing List Model");
            Restaurants = restaurantData.GetRestaurantByName(SearchKeyword);
        }
    }
}

OdeToFood/ViewComponents/RestaurantCountViewComponent.cs
using Microsoft.AspNetCore.Mvc;
using OdeToFood.Data;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace OdeToFood.ViewComponents
{
    public class RestaurantCountViewComponent : ViewComponent
    {
        private readonly IRestaurantData restaurantData;

        public RestaurantCountViewComponent(IRestaurantData restaurantData)
        {
            this.restaurantData = restaurantData;
        }

        public IViewComponentResult Invoke()
        {
            var count = restaurantData.GetRestaurantsCount();
            return View(count);
        }
    }
}

OdeToFood/Pages/Restaurants/ClientRestaurants.cshtml
@page
@model OdeToFood.Pages.Restaurants.ClientRestaurantsModel
@{
    ViewData["Title"] = "Client Restaurants";
}

<h1>Client Restaurants</h1>
<table class="table table-hover" id="restaurants">
    <thead>
        <tr>
            <th>Name</th>
            <th>Location</th>
            <th>Cuisine</th>
        </tr>
    </thead>
</table>

@section Scripts {
    <environment include="Development">
        <script src="~/datatables/js/jquery.dataTables.js"></script>
        <script src="~/datatables/js/dataTables.bootstrap4.js"></script>
        <link href="~/datatables/css/dataTables.bootstrap4.css" rel="stylesheet" />
    </environment>
    <environment exclude="Development">
        <script type="text/javascript" src="https://cdn.datatables.net/v/dt/dt-1.10.20/datatables.min.js"></script>
        <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/v/dt/dt-1.10.20/datatables.min.css" />
    </environment>

    <script>
        $(function () {
            var cuisines = ["None","Mexican","Italian","Indian","Pinoy"];

            $.ajax("/api/restaurants/", { method: "get" })
                .then(function (response) {
                    $("#restaurants").dataTable({
                        data: response,
                        columns: [
                            { "data": "name" },
                            { "data": "location" },
                            {
                                "data": "cuisine", "render": function (data)
                                {
                                    return cuisines[data];
                                }
                            }
                        ]
                    });
                });
        });
    </script>
}

OdeToFood/Pages/Restaurants/Delete.cshtml
@page "{id:int}"
@model OdeToFood.Pages.Restaurants.DeleteModel
@{
    ViewData["Title"] = "Delete";
}

<h1>Are you sure you want to delete @Model.Restaurant.Name?</h1>
<div>RestaurantID: @Model.Restaurant.Id</div>
<div>Location: @Model.Restaurant.Location</div>
<div>Cuizine: @Model.Restaurant.Cuisine</div>

<form method="post">
    <input asp-for="Restaurant.Id" hidden />
    <button type="submit" class="btn btn-danger"><i class="fa fa-trash"></i> Delete Restaurant</button>
    <a class="btn btn-danger" asp-page="./List"><i class="fa fa-times"></i> Cancel</a>
</form>

OdeToFood/Pages/Restaurants/Details.cshtml
@page "{id:int}"
@model OdeToFood.Pages.Restaurants.DetailsModel
@{
    ViewData["Title"] = "Details";
}

@if(Model.Message != null)
{
    <div class="alert alert-info">@Model.Message</div>
}

<h1>@Model.Restaurant.Name</h1>
<div>RestaurantID: @Model.Restaurant.Id</div>
<div>Location: @Model.Restaurant.Location</div>
<div>Cuizine: @Model.Restaurant.Cuisine</div>
<hr />
<a asp-page="./List" class="btn btn-primary">See All Restaurants</a>

OdeToFood/Pages/Restaurants/Edit.cshtml
@page 
@model OdeToFood.Pages.Restaurants.EditModel
@{
    ViewData["Title"] = "Edit";
}

<h1>Editing @Model.Restaurant.Name</h1>

<form method="post">
    <input asp-for="Restaurant.Id" hidden />
    <div class="form-group">
        <label asp-for="Restaurant.Name"></label>
        <input class="form-control" asp-for="Restaurant.Name" />
        <span asp-validation-for="Restaurant.Name" class="text-danger"></span>
    </div>
    <div class="form-group">
        <label asp-for="Restaurant.Location"></label>
        <input class="form-control" asp-for="Restaurant.Location"/>           
        <span asp-validation-for="Restaurant.Location" class="text-danger"></span>
    </div>
    <div class="form-group">
        <label asp-for="Restaurant.Cuisine"></label>
        <select class="form-control" asp-for="Restaurant.Cuisine" asp-items="Model.Cuisines"></select>
        <span asp-validation-for="Restaurant.Cuisine" class="text-danger"></span>
    </div>
    <button type="submit" class="btn btn-primary">Save Changes</button>
</form>


@section Scripts{ 
    <partial name="_ValidationScriptsPartial"/>
}

OdeToFood/Pages/Restaurants/Index.cshtml
@page
@model OdeToFood.Pages.Restaurants.IndexModel
@{
    ViewData["Title"] = "Index";
}

<h1>Index</h1>

OdeToFood/Pages/Restaurants/List.cshtml
@page
@model OdeToFood.Pages.Restaurants.ListModel
@{
    ViewData["Title"] = "List";
}

@if (Model.Message != null)
{
    <div class="alert alert-info">@Model.Message</div>
}

<h1>
    <a asp-page="./Edit"><i class="fa fa-plus"></i></a>
    (
        <vc:restaurant-count></vc:restaurant-count> of
        @Model.Restaurants.Count()
    ) Restaurants
</h1>
<p>Manage restaurant records. View, Add, update and delete.</p>

<form method="get">
    <div class="form-group">
        <div class="input-group">
            <input type="search" class="form-control" asp-for="@Model.SearchKeyword" placeholder="Search keyword..." value="" autofocus />
            <span class="input-group-append">
                <button class="btn btn-primary">
                    <i class="fa fa-search"></i>
                </button>
            </span>
        </div>
    </div>
</form>
@*<table class="table table-hover table-striped">
    <thead>
        <tr>
            <th>Name</th>
            <th>Location</th>
            <th>Cuisine</th>
        </tr>
    </thead>
    <tbody>
        @if (Model.Restaurants.Any())
        {
            foreach (var item in Model.Restaurants)
            {
                <tr>
                    <td>
                        <a asp-page="./Details" asp-route-id="@item.Id"><i class="fa fa-search"></i></a>
                        <a asp-page="./Edit" asp-route-id="@item.Id"><i class="fa fa-edit"></i></a>
                        <a asp-page="./Delete" asp-route-id="@item.Id"><i class="fa fa-trash"></i></a>
                        @item.Name
                    </td>
                    <td>@item.Location</td>
                    <td>@item.Cuisine.ToString()</td>
                </tr>
            }
        }
        else
        {
            <tr>
                <td colspan="100" class="text-center">No records found!</td>
            </tr>
        }

    </tbody>
</table>*@

<div class="row">
    @if (Model.Restaurants.Any())
    {
        foreach (var item in Model.Restaurants)
        {
            <partial name="_Summary" model="item" />
        }
    }
</div>

OdeToFood/Pages/Restaurants/NotFound.cshtml
@page
@{
    ViewData["Title"] = "NotFound";
}

<h1>Restaurant was not found!</h1>
<a asp-page="./List" class="btn btn-primary">See all restaurant</a>

OdeToFood/Pages/Restaurants/_Summary.cshtml
@using OdeToFood.Core
@model Restaurant

<div class="col-sm-6 col-lg-4">
    <div class="card">
        <h5 class="card-header">
            @Model.Name
            <span class="float-right">
                <a asp-page="./Details" asp-route-id="@Model.Id"><i class="fa fa-search"></i></a>
                <a asp-page="./Edit" asp-route-id="@Model.Id"><i class="fa fa-pen"></i></a>
                <a asp-page="./Delete" asp-route-id="@Model.Id"><i class="fa fa-trash"></i></a>
            </span>

        </h5>
        <div class="card-body">
            <p>Location: @Model.Location</p>
            <p>Cuisine: @Model.Cuisine.ToString()</p>
        </div>
    </div><br />
</div>